#include "HashData.h"
HashData::HashData(int size) : map(size)
{
	clear();
}

void HashData::clear()
{
	map.clear();
	keyIterator = map.end();
	valueIterator = map.end();
}

HashData::~HashData(void)
{

}

int HashData::getCount() 
{
	return (int)map.size();
}

void HashData::add(const wxString & key, wxString & value)
{
	map[key] = value;	
}

void HashData::remove(const wxString & key)
{
	map.erase(key);
}


bool HashData::getValue(const wxString & key, wxString & value)
{
	StringHashMap::iterator it = map.find(key);
	if (it == map.end()) {
		return false;
	}
	value = it->second;
	return true;
}

bool HashData::getFirstKey(wxString & key) 
{
	if (map.empty()) 
		return false;

	keyIterator = map.begin();
	key = keyIterator->first;
	return true;
}


bool HashData::hasNextKey()
{
	if (keyIterator == map.end()) { 
		return false;
	}
	return true;
}

bool HashData::getNextKey(wxString & key)
{
	// Make sure we're not already at the end
	if (keyIterator == map.end()) { 
		return false;
	}
	keyIterator++;	
	return getCurrentKey(key);
}
bool HashData::getCurrentKey(wxString & key)
{
	// Make sure there is a next value
	if (keyIterator == map.end()) { 
		return false;
	}
	key = keyIterator->first;
	return true;
}

bool HashData::getFirstValue(wxString & value)
{
	if (map.empty()) 
		return false;
	valueIterator = map.begin();
	value = valueIterator->second;
	return true;
}
bool HashData::hasNextValue()
{
	if (valueIterator == map.end()) { 
		return false;
	}
	return true;
}


bool HashData::getNextValue(wxString & value)
{
	// Make sure we're not already at the end
	if (valueIterator == map.end()) { 
		return false;
	}
	valueIterator++;
	return getCurrentValue(value);
}



bool HashData::getCurrentValue(wxString & value)
{
	// Make sure there is a current value
	if (valueIterator == map.end()) { 
		return false;
	}
	value = valueIterator->second;
	return true;
}

